unit uExcepGen;

{******************************************************************************
Initial Author   :    Scott Price
Initially Created:    05-Apr-2003
Language         :    Object Pascal
Compiler Version :    Delphi 3.02, 4.03, 5.01, 6.02 (UK)
Copyright        :     Information Technology Sector Limited, 1996-2002

Source Code Constraints:
========================
   Distribution, disclosure or modifications of this source code, outside of
   any licenced agreements with Information Technology Sector Limited, or
   removal of this notice constitutes a breach of any or all license agreements.

Operating Systems Tested On:
============================
   Microsoft Windows(R) 98, First Edition
   Microsoft Windows(R) 2000, Service Pack 2

Design Notes:
=============

VERSION  AUTHOR                DATE/TIME
===============================================================================
$history$
$nokeywords$
===============================================================================
NOTES:
===============================================================================
TODO:
******************************************************************************}


interface

uses
  Classes;

type
  TExceptionGenerator = class(TThread)
  private
    { Private declarations }
    FBits: TBits;
    procedure DoTrue;
    procedure DoFalse;
  protected
    { Protected declarations }
    procedure Execute; override;
  public
    { Public declarations }
    constructor Create(CreateSuspended: Boolean; const iSize: Integer);
    destructor Destroy; override;
  published
    { Published declarations }
  end;

implementation

{ Important: Methods and properties of objects in VCL or CLX can only be used
  in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TExceptionGenerator.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

uses
  { Borland Standard Units }
  SysUtils;


  { TExceptionGenerator }

constructor TExceptionGenerator.Create(CreateSuspended: Boolean;
  const iSize: Integer);
begin
  inherited Create(CreateSuspended);

  FreeOnTerminate := True;

  FBits := TBits.Create;
  FBits.Size := iSize;
end;

destructor TExceptionGenerator.Destroy;
begin
  TRY
    if Assigned(FBits) then
      FreeAndNil(FBits);
  FINALLY
    inherited Destroy;
  END;
end;

procedure TExceptionGenerator.DoFalse;
begin
  //Sleep(20);
end;

procedure TExceptionGenerator.DoTrue;
begin
  { You might do something here }
  //Sleep(10);
end;

procedure TExceptionGenerator.Execute;
var
  I: Integer;
begin
  { Place thread code here }
  while NOT Terminated do
  begin
    { This will generate a range exception, as it should be
    for I := 0 to FBits.Size - 1 do }
    for I := 1 to FBits.Size do
    begin
      if FBits.Bits[I] then
        DoTrue
      else
        DoFalse;
    end;
  end;
end;

end.
